/* =====================================================
**   Created by the Precognition Interface Builder
** =====================================================
**
**  Link this file with 'Precognition.o'
**
**  NOTE: The Intuition and Graphics libraries *MUST* be
**  opened before calling this function!
*/

#include "Precognition.h"
#ifndef __GNUC__
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#include <proto/intuition.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#include <proto/intuition.h>
#endif
#include "intuition_utils.h"

#include <stdio.h>

#define X0 20
#define X1 (X0+30)
#define Y0 20
#define Y1 (Y0+20)
#define Y2 (Y1+20)
#define Y3 (Y2+20)
#define Y4 (Y3+20)
#define Y5 (Y4+20)

void do_About_window( Screen         *screen,
                      struct MsgPort *port )
{
   pcgWindow     About_window;
   pcg_3DPens    pens;
   BOOL          done;
   IntuiMessage *message, event;
   BoolGadget    OK_button;
   struct IntuiText About_text[6];
   struct TextAttr bold, italic;

   bold = pcg_Topaz80;
   bold.ta_Style |= FSF_BOLD;

   italic = pcg_Topaz80;
   italic.ta_Style = FSF_ITALIC;


   About_text[0].FrontPen  = 1;
   About_text[0].BackPen   = 0;
   About_text[0].DrawMode  = JAM1;
   About_text[0].LeftEdge  = X0;
   About_text[0].TopEdge   = Y0;
   About_text[0].ITextFont = &pcg_Topaz80;
   About_text[0].IText     = "Precognition";
   About_text[0].NextText  = &About_text[1];

   About_text[1]           = About_text[0];
   About_text[1].LeftEdge  = X1;
   About_text[1].TopEdge   = Y1;
   About_text[1].IText     = "\"a step beyond Intuition\"";
   About_text[1].NextText  = &About_text[2];

   About_text[2]           = About_text[0];
   About_text[2].TopEdge   = Y2;
   About_text[2].IText     = "Version 2.1, November 17, 1994";
   About_text[2].NextText  = &About_text[3];

   About_text[3]           = About_text[0];
   About_text[3].TopEdge   = Y3;
   About_text[3].IText     = "1994 Edward D. Berger";
   About_text[3].NextText  = &About_text[4];

   About_text[4]           = About_text[0];
   About_text[4].TopEdge   = Y4;
   About_text[4].IText     = "1991, 1992, 1993 WILLISoft";
   About_text[4].NextText  = &About_text[5];

   About_text[5]           = About_text[0];
   About_text[5].TopEdge   = Y5;
   About_text[5].IText     = "Originally Developed by Lee Willis";
   About_text[5].NextText  = NULL;

   About_text[0].ITextFont = &bold;
   About_text[1].ITextFont = &italic;

/*   pens = StandardPens();  */
   pens = StandardScreenPens( screen );

   /* Initialize the window */
   pcgWindow_Init( &About_window,
      40, 40, 327, 159, /* LeftEdge, TopEdge, Width, Height */
      100, 50, 65535, 65535, /* min width & height, max width & height */
      "About Precognition...", /* title */
      REFRESHWINDOW | CLOSEWINDOW, /* IDCMPFlags */
      WINDOWDRAG | WINDOWDEPTH | WINDOWCLOSE | SIMPLE_REFRESH | ACTIVATE, /* Flags */
      screen ); /* pointer to screen */
   About_window.SharedUserPort = port;

   BoolGadget_Init( &OK_button,
      116, 140, 96, 12, /* LeftEdge, TopEdge, Width, Height */
      pens, "OK" );
   SetTextAlignment( (struct GraphicObject *)&OK_button, tx_XCENTER | tx_YCENTER, 0, 0 );
   AddWindowPObject( &About_window, (GraphicObject*) &OK_button );

   /*  Open the window (returns NULL on failure) */
   if( pcgOpenWindow( &About_window ) )
   {
      Refresh( (struct Interactor *)&About_window ); /* Draw the window graphics. */
      PrintIText( RPort( &About_window ), About_text, 0, 0 );

      done = FALSE;
      while( !done ) /* Main event loop */
      {
         message = WaitForMessage( About_window.Window->UserPort );
         event   = *message; /* Make a local copy of the message */
         ReplyMsg( (struct Message *)message );

         switch( event.Class )
         {

            case CLOSEWINDOW:
               done = TRUE; /* exit the loop.  */
               break;

            case REFRESHWINDOW:
               {
                  pcgWindow *w;

                  w = (pcgWindow *)event.IDCMPWindow->UserData;
                  BeginRefresh( event.IDCMPWindow );
                  Refresh( (struct Interactor *)w );

                  if( w == &About_window )
                  {
                     PrintIText( RPort( w ), About_text, 0, 0 );
                  }
                  EndRefresh( event.IDCMPWindow, TRUE );
               }
               break;

            default:
               if( Respond( (Interactor *)&OK_button, &event ) & CHANGED_STATE )
               {  /* OK_button was hit. */
                  done = TRUE;
               }

         } /* end switch */

      } /* end loop */

      pcgCloseWindow( &About_window );
   } /* end if */

   else /* Window could not be opened. */
   {
      ; /*** YOUR ERROR HANDLING HERE ***/
   }
   CleanUp( (PObject *)&About_window );
   CleanUp( (PObject *)&OK_button );
}
