
#include "CycleGadgetIO.h"
#include "ValuatorIO.h"
#include "StringListIO.h"
#include "ValuatorClass.h"

long WriteCycleGadgetChunk( GraphicObject* obj, FILE *file )
{
   long beginkey;
   CycleGadget *cycler = (CycleGadget *)obj;

   beginkey = IFF_BeginGroupChunk( file, FORM, CYCG );

   if( beginkey >= 0 )
   {
      WriteValuatorChunk( (struct GraphicObject *)cycler, file, CYCG );

      WriteStringList( file, &cycler->sl );

      IFF_EndChunk( file, beginkey );
   }

   return beginkey;
}

extern LONG CycleGadget_SetValue       ( CycleGadget*, LONG );
extern LONG CycleGadget_SV_NoRangeCheck( CycleGadget*, LONG );
extern struct ValuatorClass CycleGadget_Class;



GraphicObject* ReadCycleGadgetChunk( PClass            *class,
                                     FILE             *file,
                                     struct ChunkInfo *chunk )
{
   CycleGadget *cycler;
   struct ChunkInfo subchunk;
   long pos, status;

   for(;;)
   {
      status = pos = ftell( file );
      if( status < 0 ) break;

      if( pos >= chunk->end ) break;

      status = IFF_ReadChunkInfo( file, &subchunk );
      if( status < 0 ) break;

      if( subchunk.Id == CYCG )
      {

/****** KLUGE ALERT ****
***
*** I have to override the SetValue method to bypass range checking
*** here, because the cyclegadget doesn't yet have any choices, so
*** range checking always force the value to be 0.
***
************************/

         CycleGadget_Class.SetValue = (LONG(*)(Valuator *, LONG))CycleGadget_SV_NoRangeCheck;

         cycler = (CycleGadget *)ReadValuatorChunk( class, file, &subchunk );

         CycleGadget_Class.SetValue = (LONG(*)(Valuator *, LONG))CycleGadget_SetValue;
      }

      else if( ( subchunk.Id == LIST ) && ( subchunk.GroupId == CHRS ) )
      {
         ReadStringList( file, &subchunk, &cycler->sl );

         SetValue( (Valuator *)cycler, Value( (Valuator *)cycler) );
      }


      /* seek to next chunk */
      fseek( file, subchunk.next, SEEK_SET );
   }

   return (GraphicObject *)cycler;
}

