
#include "IFFio.h"


#ifdef VERBOSE
#define VERBIAGE(s) printf s
#else
#define VERBIAGE(s)
#endif

long IFF_BeginChunk( FILE *file, ID id )
{
   long pos, length;
   long status;

   status = pos = ftell( file );

   if( status >= 0 )
   {
      length = 0;

      status = fwrite( &id, sizeof( ID ), 1,  file );

      if( status >= 0 )
      {
         status = fwrite( &length, sizeof( ID ), 1,  file );

         if( status >= 0 )
            return pos;
      }
   }
   return status;
}

long IFF_BeginGroupChunk( FILE *file, ID grpid, ID typeid  )
{
   long pos, status;

   status = pos = IFF_BeginChunk( file, grpid );

   if( status >= 0 )
   {
      status = fwrite( &typeid, sizeof( ID ), 1,  file );

      if( status >= 0 )
         return pos;
   }
   return status;
}


#define IS_ODD(i) (i & 0x01 )

long IFF_EndChunk( FILE *file, long beginpos )
{
   long pos;
   long length; /* Chunk body length */
   long status;

   status = pos = ftell( file );

   if( status >= 0 )
   {
      length = ( pos - beginpos ) - 8;

      status = fseek( file, beginpos +4, SEEK_SET ); /* Go to header   */

      if( status >= 0 )
      {
         status = fwrite( &length, sizeof( long ), 1,  file );
                  /* fill in length */

         if( status >= 0 )
         {
            status = fseek( file, pos, SEEK_SET );
            if( status < 0 )
               printf("IFF_EndChunk: error inner fseek\n");

            if( IS_ODD( pos ) )
            {
               long pad = 0;
               status = fwrite( &pad, sizeof( BYTE ), 1,  file );
               if( status < 0 )
                  printf( "IFF_EndChunk: error writing Pad byte.\n" );
            }

         }
         else
            printf( "IFF_EndChunk: error fwrite()\n" );
      }
      else
         printf( "IFF_EndChunk: error fseek()\n" );
   }
   else
      printf( "IFF_EndChunk: error ftell()\n" );

   return status;
}

long IFF_ReadChunkInfo( FILE *file, struct ChunkInfo *info )
{
   long status;

   status = info->start = ftell( file );

   if( status < 0 ) return status;

   status = fread( info, 8, 1, file );

   if( status <= 0 ) return status;

   info->end = info->start + info->length + 8 - 1;
   info->next = info->end + 1;

   if IS_ODD( info->next ) info->next++;

   if ( ( info->Id == FORM )
     || ( info->Id == LIST )
     || ( info->Id == CAT )
     || (info->Id == PROP ) )
   {
      status = fread( &info->GroupId, 4, 1, file );
   }
   else
      info->GroupId = 0L;

VERBIAGE( ( "ReadChunkInfo : Id=\"%4s\", length=%d, GroupId=\"%4s\"\n",  (char*) (&info->Id), info->length, (char*) (&info->GroupId) ));

   return status;
}
