#ifndef IFFIO_H
#define IFFIO_H

#include <stdio.h>
#include <exec/types.h>

typedef LONG ID;	/* An ID is four printable ASCII chars but
			 * stored as a LONG for efficient copy & compare.*/

/* Four-character IDentifier builder.*/
#define MakeID(a,b,c,d)  ( (LONG)(a)<<24L | (LONG)(b)<<16L | (c)<<8 | (d) )

/* Standard group IDs.  A chunk with one of these IDs contains a
   SubTypeID followed by zero or more chunks.*/
#define FORM MakeID('F','O','R','M')
#define PROP MakeID('P','R','O','P')
#define LIST MakeID('L','I','S','T')
#define CAT  MakeID('C','A','T',' ')
#define FILLER MakeID(' ',' ',' ',' ')
/* The IDs "FOR1".."FOR9", "LIS1".."LIS9", & "CAT1".."CAT9" are reserved
 * for future standardization.*/



long IFF_BeginChunk( FILE *file, ID id );

long IFF_BeginGroupChunk( FILE *file, ID grpid, ID typeid  );

long IFF_EndChunk( FILE *file, long beginpos );


struct ChunkInfo
{
   ID   Id;
   long length;
   ID   GroupId;
   long start;    /* abs position of where the chunk header starts. */
   long end;      /* abs position of where chunk ends               */
   long next;     /* abs position of where the next chunk starts.   */
};

long IFF_ReadChunkInfo( FILE *file, struct ChunkInfo *info );

#endif