#include <stdio.h>
#include "Positioner_coder.h"
#include "CodeWriter.h"
#include "VSliderClass.h"
#include "HSliderClass.h"
#include "VScrollerClass.h"
#include "HScrollerClass.h"

#define FP fprintf( file,
/* #define FP printf(  */

void Positioner_WriteCode(  Positioner    *self,
                            BuilderWindow *bw,
                            FILE          *file,
                            UWORD          section )
{
   char *name, *title, *classname;
   Point size, location;

   name      = PObjectName( (struct PObject *)self );
   classname = ClassName( (struct PObject *)self );

  /*  printf("Write Code for %s\n", ClassName(self) );  */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         if( isa( (struct PObject *)self, VSliderClass() ) || isa( (struct PObject *)self, HSliderClass() ) )
            FP "   %s\t\t\t%s;\n", classname, name );
         else
            FP "   %s\t\t%s;\n", classname, name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );
         size     = Size( (struct GraphicObject *)self );
         title    = Title( (struct GraphicObject *)self );
         FP "   %s_Init( &window->%s,\n", classname, name );

         if( isa( (struct PObject *)self, VSliderClass() ) || isa( (struct PObject *)self, HSliderClass() ) )
         {
            FP "      %d, %d, %d, %d, /* LeftEdge, TopEdge, Width, Height */\n",
                location.x, location.y, size.x, size.y );
         }
         else if( isa( (struct PObject *)self, VScrollerClass() ) )
         {
            FP "      %d, %d, %d, /* LeftEdge, TopEdge, Height */\n",
                location.x, location.y, size.y );
         }
         else if( isa( (struct PObject *)self, HScrollerClass() ) )
         {
            FP "      %d, %d, %d, /* LeftEdge, TopEdge, Width */\n",
                location.x, location.y, size.x );
         }


         FP "      pens, ");
         if( title )
                FP "\"%s\" );\n", title );
         else
                FP "NULL );\n" );
         FP "   SetKnobSize( (Positioner *)&window->%s, %d ); /* Knob size */\n",
            name, KnobSize( (Positioner *)self ) );
         FP "   SetValue( (Valuator *)&window->%s, %d ); /* Knob position */\n",
            name, (USHORT) Value( (Valuator *)self ) );

         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n",
               name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (Interactor *)&window->%s, event );\n", name );
         FP "            if( r & CHANGED_STATE )\n");
         FP "            {  /*\n");
         FP "               ** %s %s has been changed.\n", classname, name );
         FP "               ** \n");
         FP "               ** To read the current value of %s, do:\n", name );
         FP "               ** \n");
         FP "               **    USHORT position, knob;\n");
         FP "               **    position = (USHORT) Value( (Valuator *)&window->%s );\n", name );
         FP "               **    knob     = KnobSize( (Positioner *)&window->%s );\n", name );
         FP "               */\n");
         FP "               ; /* YOUR CODE HERE */\n");
         FP "               response |= r;\n");
         FP "            }\n\n");
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

   }
}
