
#include "StringListerIO.h"
#include "GraphicObjectIO.h"
#include "StringListIO.h"
#include "ValuatorClass.h"

long WriteStringListerChunk( GraphicObject* obj, FILE *file, long Id )
{
   long beginkey;
   StringLister *lister = (StringLister*) obj;

   beginkey = IFF_BeginGroupChunk( file, FORM, Id );

   if( beginkey >= 0 )
   {
      WriteGfxObjChunk( (struct GraphicObject *)lister, file, Id );

      WriteStringList( file, StringList_of(lister) );

      IFF_EndChunk( file, beginkey );
   }

   return beginkey;
}



GraphicObject* ReadStringListerChunk( PClass            *class,
                                      FILE             *file,
                                      struct ChunkInfo *chunk,
                                      long              Id )
{
   StringLister *lister;
   struct ChunkInfo subchunk;
   long pos, status;
   struct StringList slist;
   int i;

   for(;;)
   {
      status = pos = ftell(file);
      if (status < 0) break;

      if (pos >= chunk->end) break;

      status = IFF_ReadChunkInfo( file, &subchunk );
      if (status < 0) break;

      if  (subchunk.Id == Id)
      {
         lister = (StringLister*) ReadGfxObjChunk( class, file, &subchunk );
      }

      else if ((subchunk.Id == LIST) && (subchunk.GroupId == CHRS))
      {
         StringList_Init( &slist, FALSE );

         ReadStringList( file, &subchunk, &slist );

         for (i=0; i<slist.nEntries; i++)
         {
            AddString( lister, slist.Entries[i], 0 );
         }

         StringList_CleanUp( &slist );

      }

      /* seek to next chunk */
      fseek( file, subchunk.next, SEEK_SET );
   }

   return (GraphicObject *)lister;
}

