#include <stdio.h>
#include "BoolGadget_coder.h"
#include "CodeWriter.h"

#define FP fprintf( file,
/* #define FP printf(   */

void BoolGadget_WriteCode(  BoolGadget    *self,
                            BuilderWindow *bw,
                            FILE          *file,
                            UWORD          section )
{
   char *name, *title;
   Point size, location;

   name = self->PObjectName;

   /* printf( "Write Code for %s\n", ClassName( self ) );  */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         FP "   BoolGadget\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );
         size     = Size( (struct GraphicObject *)self );
         title    = Title( (struct GraphicObject *)self );
         FP "   BoolGadget_Init( &window->%s,\n", name );
         FP "      %d, %d, %d, %d, /* LeftEdge, TopEdge, Width, Height */\n",
            location.x, location.y, size.x, size.y );
         FP "      pens, ");
         if( title )
            FP "\"%s\" );\n", title );
         else
            FP "NULL );\n" );

         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n",
            name );
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (struct Interactor *)&window->%s, event );\n", name );
         FP "            if( r & CHANGED_STATE )\n" );
         FP "            {  /* %s was hit. */\n", name );
         FP "               response |= r;\n" );
         FP "               ; /* YOUR CODE HERE */\n" );
         FP "            }\n\n" );
         break;

   }
}
