#include <stdio.h>
#include "CheckBox_coder.h"
#include "CodeWriter.h"

#define FP fprintf( file,
 /* #define FP printf(  */

void CheckBox_WriteCode(  CheckBox      *self,
                          BuilderWindow *bw,
                          FILE          *file,
                          UWORD          section )
{
   char *name, *title;
   Point location;

   name = PObjectName( (struct PObject *)self );
   title = Title( (struct GraphicObject *)self );
   if( title == NULL )
      title = "";

  /*  printf("Write Code for %s\n", ClassName( self ) );  */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         FP "   CheckBox\t\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );

         FP "   CheckBox_Init( &window->%s,\n", name );
         FP "      %d, %d, /* LeftEdge, TopEdge, */\n",
            location.x, location.y );
         FP "      pens, \"%s\",\n", title );
         FP "      ");

         if( Value( (Valuator *)self ) ) FP "TRUE");
         else FP "FALSE");
         FP " ); /* Initially checked? */\n");
         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n",
                  name );
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (struct Interactor *)&window->%s, event );\n", name );
         FP "            if( r & CHANGED_STATE )\n");
         FP "            { /* %s was hit. */\n", name );
         FP "               response |= r;\n\n");
         FP "               if( Value( (Valuator *)&window->%s ) ) /* %s is checked. */\n", name, name );
         FP "               { \n");
         FP "                  ; /* YOUR CODE HERE */\n");
         FP "               }\n");
         FP "               else /* %s is NOT checked. */\n", name );
         FP "               { \n");
         FP "                  ; /* YOUR CODE HERE */\n");
         FP "               }\n");
         FP "            }\n\n");
         break;

   }
}
