#include <stdio.h>
#include "CycleGadget_coder.h"
#include "CodeWriter.h"

#define FP fprintf( file,
  /* #define FP printf(   */

void CycleGadget_WriteCode(  CycleGadget    *self,
                            BuilderWindow *bw,
                            FILE          *file,
                            UWORD          section )
{
   char *name, *title;
   Point size, location;
   USHORT i;

   name = PObjectName( (struct PObject *)self );

  /* printf("Write Code for %s\n", ClassName(self) );  */


   switch( section )
   {
      case CODE_GLOBALS:
         if( self->sl.nEntries > 0 )
         {
            FP "char *%s_options[] = \n", name );
            FP "   {\n");
            for( i = 0; i < self->sl.nEntries; i++ )
               FP "      \"%s\",\n", self->sl.Entries[i] );
            FP "      NULL\n");
            FP "   };\n\n");
         }
         break;

      case CODE_MIDDLE_WSTRUCT:
         FP "   CycleGadget\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );
         size     = Size( (struct GraphicObject *)self );
         FP "   CycleGadget_Init( &window->%s,\n", name );
         FP "      %d, %d, %d, /* LeftEdge, TopEdge, Width */\n",
            location.x, location.y, size.x );
         FP "      pens, ");
         if( title = Title( (struct GraphicObject *)self ) )
            FP "\"%s\", ", title );
         else
            FP "NULL, ");

         if( self->sl.nEntries )
            FP "%s_options );\n", name );
         else
            FP "NULL );\n" );

         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n",
                name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (struct Interactor *)&window->%s, event );\n", name );
         FP "            if( r & CHANGED_STATE )\n" );
         FP "            {  /* %s was cycled.  The current selection \n", name );
         FP "               ** can be determined by doing:\n");
         FP "               **\n");
         FP "               **       long v;\n");
         FP "               **       v = Value( (Valuator *)&window->%s );\n", name );
         FP "               */\n");
         FP "               ; /* YOUR CODE HERE */\n" );
         FP "               response |= r;\n" );
         FP "            }\n\n");
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

   }
}
