#include <stdio.h>
#include "ListEditor_coder.h"
#include "CodeWriter.h"
#include "BuilderMethods.h"

#define FP fprintf( file,
/* #define FP printf( */

extern struct FlagPair EntryFlags[3];

#include "dumpwait.h"

void ListEditor_WriteCode(  ListEditor    *self,
                            BuilderWindow *bw,
                            FILE          *file,
                            UWORD          section )
{
   char *name, *title;
   Point location;
   Point size;
   USHORT i;
   StringList *sl;

   name = PObjectName( (struct PObject *)self );

  /* printf("Write Code for %s\n", ClassName(self) ); */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         FP "   ListEditor\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );
         size     = Size( (struct GraphicObject *)self );
         FP "   ListEditor_Init( &window->%s,\n", name );
         FP "      %d, %d, %d, %d, /* LeftEdge, TopEdge, Width, Height */\n",
            location.x, location.y, size.x, size.y );
         FP "      pens, ");
         if( title = Title( (struct GraphicObject *)self ) )
            FP "\"%s\");\n", title );
         else
            FP "NULL );\n" );

         sl = StringList_of( (StringLister *)self );
         if( sl->nEntries )
         {
            FP "      /*\n");
            FP "      ** Add string entries to %s\n", name );
            FP "      */\n");
            for( i = 0; i < sl->nEntries; i++ )
            {
               FP "   AddString( (StringLister*) &window->%s, \"%s\", ",
                  name, sl->Entries[i] );
               WriteFlags( file, sl->Qualifiers[i], EntryFlags, 3 );
               FP " );\n");
            }
         }

         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n", name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (struct Interactor *)&window->%s, event );\n", name );
         FP "            if( r & CHANGED_STATE )\n");
         FP "            { /* An item was selected/added/deleted. */\n" );
         FP "               int i;\n" );
         FP "               char* selected_item;\n" );
         FP "               StringList  *stringlist;\n" );
         FP "\n" );
                                         /* EDB -- added cast to (StringLister *) */
         FP "               stringlist = StringList_of( (StringLister *)&window->%s );\n", name );
         FP "               for( i = 0; i < stringlist->nEntries; i++ )\n" );
         FP "               { /* Find selected item(s) */ \n" );
         FP "                  if( stringlist->Qualifiers[i] & ENTRY_SELECTED ) \n" );
         FP "                  {\n" );
         FP "                     selected_item = stringlist->Entries[i];\n" );
         FP "                     /* 'selected_item' is selected. */\n");
         FP "                     ; /* YOUR CODE HERE */\n");
         FP "                  } \n" );
         FP "               }\n");
         FP "              response |= r;\n");
         FP "            }\n\n");
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

   }
}
