#include <stdio.h>
#include "OutlineBox.h"
#include "OutlineBox_coder.h"
#include "CodeWriter.h"

#define FP fprintf( file,
/* #define FP printf(   */

void OutlineBox_WriteCode( OutlineBox      *self,
                           BuilderWindow *bw,
                           FILE          *file,
                           UWORD          section )
{
   char *name, *title;

   Point size, location;

   name = PObjectName( (struct PObject *)self );


  /*  printf("Write Code for %s\n", ClassName(self) );  */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         FP "   OutlineBox\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         size     = Size( (struct GraphicObject *)self );
         location = Location( (struct GraphicObject *)self );
         title    = Title( (struct GraphicObject *)self );

         FP "   OutlineBox_Init( &window->%s,\n", name );
         FP "      %d, %d, %d, %d, /* LeftEdge, TopEdge, Width, Height */\n",
            location.x, location.y, size.x, size.y );
         FP "      pens, " );
         if( title )
            FP "\"%s\" );\n", title );
         else
            FP "NULL );\n" );
         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n", name );

         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

   }
}

