#include "BoolGadget.h"
#include "BoolGadgetClass.h"
#include "amigamem.h"

#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "BoolGadget_coder.h"
#include "GraphicObjectIO.h"
#include "BoolGadgetIO.h"

/* Replace BoolGadget with void -- EDB */
void *BoolGadget_New( BoolGadget *self )
{
   BoolGadget *new_self;

   if( new_self = (BoolGadget *)Amalloc( sizeof( BoolGadget ) ) )
   {

      if( self )
      {
         char *label = Title( (GraphicObject *)self );
         BoolGadget_Init( new_self, self->Location.x, self->Location.y,
            self->Size.x, self->Size.y, self->Pens, label );
      }
      else
      {
         BoolGadget_Init( new_self, 0, 0, 64, 14, StandardPens(), NULL );
      }
      GiveItAName( (struct PObject *)new_self );
   }

   return new_self;
}

struct BuilderMethods BoolGadget_bm;


void
patchBoolGadgetClass( void )
{
   struct ValuatorClass *class;

   class = BoolGadgetClass();

   class->BuilderMethods = &BoolGadget_bm;
   go_InitBuilderMethods( &BoolGadget_bm );
   BoolGadget_bm.New       = (void*(*)(PObject *))BoolGadget_New;
   BoolGadget_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))BoolGadget_WriteCode;
   BoolGadget_bm.WriteIFF  = WriteBoolGadgetChunk;
   BoolGadget_bm.ReadIFF   = ReadGfxObjChunk;
}
