#include <stdio.h>
#include <string.h>

#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "CycleGadget_builder.h"
#include "CycleGadget_coder.h"
#include "CycleGadgetIO.h"

#include "CycleGadget.h"
#include "CycleGadgetClass.h"
#include "ValuatorClass.h"
#include "AmigaMem.h"
#include <proto/exec.h>
#include <proto/graphics.h>
#include <proto/intuition.h>


LONG CycleGadget_SV_NoRangeCheck( CycleGadget *self,
                                  LONG         selection )
{
   self->bg.state = selection;

   return (LONG)selection;
}


CycleGadget *CycleGadget_New( CycleGadget *self )
{
   CycleGadget *cycle = NULL;
   USHORT i;


   char **choices;

   if( cycle = (CycleGadget *)Amalloc( sizeof( CycleGadget ) ) )
   {
      if( self )
      {
         StringList *sl;

         sl = &(self->sl);

         choices = (char **)Acalloc( sizeof( char * ), sl->nEntries +1 );

         for( i=0; i < sl->nEntries; i++ )
         {
            choices[i] = sl->Entries[i];
         }

         choices[sl->nEntries] = NULL;

         CycleGadget_Init(  cycle,
                            self->bg.Location.x, self->bg.Location.y,
                            self->bg.Size.x,     self->bg.Pens,
                            Title( (struct GraphicObject *)self ),         choices );
         Afree( choices );
      }
      else
      {
         CycleGadget_Init( cycle, 0, 0, 64, StandardPens(), NULL, NULL );
      }

      GiveItAName( (struct PObject *)cycle );
   }

   return cycle;
}


struct BuilderMethods CycleGadget_bm;

void
patchCycleGadgetClass( void )
{
   struct ValuatorClass *class;

   class = CycleGadgetClass();

   go_InitBuilderMethods( &CycleGadget_bm );
   class->BuilderMethods = &CycleGadget_bm;

   CycleGadget_bm.New       = (void*(*)(PObject*))CycleGadget_New;
   CycleGadget_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))CycleGadget_PropEdit;
   CycleGadget_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))CycleGadget_WriteCode;
   CycleGadget_bm.WriteIFF  = WriteCycleGadgetChunk;
   CycleGadget_bm.ReadIFF   = ReadCycleGadgetChunk;

}
