/* ==========================================================================
**
**                         HScroller.c
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#include <string.h>
#include "HScroller.h"
#include "HScrollerClass.h"
#include "amigamem.h"

#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "Positioner_Builder.h"
#include "Positioner_coder.h"
#include "PositionerIO.h"

long WriteHScrollerChunk( GraphicObject *obj, FILE* file )
{
   return WritePosrChunk( obj, file, HSCR );
}

struct BuilderMethods HScroller_bm;

/* Changed from HScroller to void -- EDB */
void *HScroller_New( HScroller *self )
{
   HScroller *new_HScroller = NULL;

   if( new_HScroller = (HScroller *)Amalloc( sizeof( HScroller ) ) )
   {
      if( self )
      {
         HScroller_Init( new_HScroller,   self->posr.Location.x, self->posr.Location.y,
                         self->posr.Size.x,  self->Pens,
                         Title( (struct GraphicObject *)self ) );
      }
      else
      {
         HScroller_Init( new_HScroller, 0,0, 64, StandardPens(), NULL );
      }
      GiveItAName( (struct PObject *)new_HScroller );
   }
   return new_HScroller;
}


void
patchHScrollerClass( void )
{
   struct PositionerClass *class;

   class = HScrollerClass();

   go_InitBuilderMethods( &HScroller_bm );

   HScroller_bm.New       = (void *(*)(PObject *))HScroller_New;
   HScroller_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))Positioner_PropEdit;
   HScroller_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))Positioner_WriteCode;
   HScroller_bm.WriteIFF  = WriteHScrollerChunk;
   HScroller_bm.ReadIFF   = ReadPosrChunk;
   class->BuilderMethods  = &HScroller_bm;

}
