/* ==========================================================================
**
**                         HSlider.c
** 1991 WILLISoft
**
** ==========================================================================
*/

#include "HSlider.h"
#include "HSliderClass.h"
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "Positioner_Builder.h"
#include "Positioner_Coder.h"
#include "PositionerIO.h"

long WriteHSliderChunk( GraphicObject *obj, FILE* file )
{
   return WritePosrChunk( obj, file, HSLI );
}

/* Changed from Slider to void -- EDB */
void *HSlider_New( HSlider *self )
{
   Slider *new_HSlider = NULL;
   Point loc, size;

   if( new_HSlider = (HSlider *)Amalloc( sizeof( HSlider ) ) )
   {
      if( self )
      {
         loc  = Location( (struct GraphicObject *)self );
         size = Size( (struct GraphicObject *)self );

         HSlider_Init( new_HSlider, loc.x, loc.y, size.x, size.y,
                       self->eg.Pens, Title( (struct GraphicObject *)self ) );
      }
      else
         HSlider_Init( new_HSlider, 0, 0, 64, 12, StandardPens(), NULL );

      GiveItAName( (struct PObject *)new_HSlider );
   }
   return new_HSlider;
}
struct BuilderMethods HSlider_bm;


void
patchHSliderClass( void )
{
   struct PositionerClass *class;

   class = HSliderClass();

   go_InitBuilderMethods( &HSlider_bm );

   HSlider_bm.New        = (void *(*)(PObject *))HSlider_New;
   HSlider_bm.PropEdit   = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))Positioner_PropEdit;
   HSlider_bm.WriteCode  = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))Positioner_WriteCode;
   HSlider_bm.WriteIFF   = WriteHSliderChunk;
   HSlider_bm.ReadIFF    = ReadPosrChunk;

   class->BuilderMethods = &HSlider_bm;

}
