#include <stdio.h>
#include <stdlib.h>
#include "IntegerGadget.h"
#include "IntegerGadgetClass.h"
#include "StringGadgetClass.h"
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "IntegerGadget_coder.h"
#include "StringGadget_Builder.h"
#include "StringGadgetIO.h"

/* Changed from IntegerGadget to void -- EDB */
void *
IntegerGadget_New( IntegerGadget *self )
{
   IntegerGadget *new_gadget;
   struct StringInfo *stringinfo;

   if( new_gadget = (IntegerGadget *)Amalloc( sizeof( IntegerGadget ) ) )
   {
      if( self )
      {
         stringinfo = (struct StringInfo *)self->g.SpecialInfo;

          IntegerGadget_Init( new_gadget,
             self->Location.x, self->Location.y,
             self->Size.x, stringinfo->MaxChars-1,
             self->Pens,   Title( (struct GraphicObject *)self ) );
          new_gadget->g.Flags      = self->g.Flags;
          SetStringValue( (Valuator *)new_gadget, StringValue( (Valuator *)self ) );
      }
      else
      {
         IntegerGadget_Init( new_gadget, 0,0, 64, 10, StandardPens(), NULL );
      }

      GiveItAName( (struct PObject *)new_gadget );

   }
   return new_gadget;
}

long IntegerGadget_WriteIFF( GraphicObject *obj, FILE* file )
{
   return WriteStringGadgetChunk( obj, file, INTG );
}

struct BuilderMethods IntegerGadget_bm;

void
patchIntegerGadgetClass( void )
{
    struct ValuatorClass *class;

   class = IntegerGadgetClass();

   class->BuilderMethods = &IntegerGadget_bm;
   go_InitBuilderMethods( &IntegerGadget_bm );

   IntegerGadget_bm.New       = (void *(*)(PObject *))IntegerGadget_New;
   IntegerGadget_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))StringGadget_PropEdit;
   IntegerGadget_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))IntegerGadget_WriteCode;
   IntegerGadget_bm.WriteIFF  = IntegerGadget_WriteIFF;
   IntegerGadget_bm.ReadIFF   = ReadStringGadgetChunk;

}
