
/* ==========================================================================
**
**                            ListEditor.c
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#include "ListEditor.h"
#include "ListEditorClass.h"
#include "EmbossedGadgetClass.h"
#include <stdlib.h>
#include <string.h>
#include "amigamem.h"

#define STATE_ADDING  2
#define STATE_EDITING 1
#define STATE_NOTHING 0

#define BROWSE &self->browse
#define EDIT   &self->edit
#define ADD    &self->add
#define DELETE &self->delete


#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "ListEditor_coder.h"
#include "ScrollingList_builder.h"
#include "StringListerIO.h"

/* Changed from ListEditor to void -- EDB */
void *
ListEditor_New( ListEditor *self )
{
   ListEditor *new_le;
   Point loc, size;
   StringList *sl1, *sl2;

   if( new_le = (ListEditor *)Amalloc( sizeof( ListEditor ) ) )
   {
      if( self )
      {
         loc  = Location( (struct GraphicObject *)self );
         size = Size( (struct GraphicObject *)self );

         ListEditor_Init( new_le, loc.x, loc.y, size.x, size.y,
                  self->add.Pens,
               Title( (struct GraphicObject *)self ) );

         sl1 = StringList_of( (StringLister *)self );
         sl2 = StringList_of( (StringLister *)new_le );
         StringList_Dup( sl1, sl2 );
      }
      else
         ListEditor_Init( new_le, 0, 0, 128, 64, StandardPens(), NULL );

      GiveItAName( (struct PObject *)new_le );
      return new_le;
   }
   return NULL;
}


long ListEditor_WriteIFF( GraphicObject *obj, FILE *file )
{
   return WriteStringListerChunk( obj, file, LSED );
}

GraphicObject* ListEditor_ReadIFF( PClass            *class,
                                   FILE             *file,
                                   struct ChunkInfo *chunk )
{
   return ReadStringListerChunk( class, file, chunk, LSED );
}

struct BuilderMethods ListEditor_bm;

/* void ScrollingList_PropEdit(); */ /* Prototype into Non-Prototype -- EDB */
extern void ScrollingList_PropEdit( ScrollingList *self,
                             pcgWindow     *window,
                             pcg_3DPens     pens );


void
patchListEditorClass(void)
{
   struct StringListerClass *class;

   class = ListEditorClass();

   go_InitBuilderMethods( &ListEditor_bm );

   ListEditor_bm.New       = (void *(*)(PObject *))ListEditor_New;
   ListEditor_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))ListEditor_WriteCode;
   ListEditor_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))ScrollingList_PropEdit;
   ListEditor_bm.WriteIFF  = ListEditor_WriteIFF;
   ListEditor_bm.ReadIFF   = ListEditor_ReadIFF;

   class->BuilderMethods   = &ListEditor_bm;
}

