#include <string.h>
#include "minmax.h"
#include "ScrollingList.h"
#include "ScrollingListClass.h"
#include "EmbossedGadgetClass.h"
#include "precognition.h"
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"


#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "ScrollingList_Builder.h"
#include "ScrollingList_Coder.h"
#include "StringListerIO.h"

void ScrollingList_PropEdit( ScrollingList *self,
                             pcgWindow     *window,
                             pcg_3DPens     pens );

/* Changed from ScrollingList to void -- EDB */
void *ScrollingList_New( ScrollingList *self )
{
   ScrollingList *new_list = NULL;
   Point loc, size;

   if( new_list = (ScrollingList *)Amalloc( sizeof( ScrollingList ) ) )
   {
      if( self )
      {
         loc  = Location( (struct GraphicObject *)self );
         size = Size( (struct GraphicObject *)self );

         ScrollingList_Init( new_list, loc.x, loc.y,
            size.x, size.y, self->Pens, self->list.SelectMany );
         StringList_Dup( &self->list.List, &new_list->list.List );
      }
      else
         ScrollingList_Init( new_list, 0,0, 128, 64, StandardPens(), FALSE );

      GiveItAName( (struct PObject *)new_list );
   }
   return new_list;
}

struct BuilderMethods ScrollingList_bm;

long ScrollingList_WriteIFF( GraphicObject *obj, FILE *file )
{
   return WriteStringListerChunk( obj, file, SCRL );
}

GraphicObject* ScrollingList_ReadIFF( PClass            *class,
                                      FILE             *file,
                                      struct ChunkInfo *chunk )
{
   return ReadStringListerChunk( class, file, chunk, SCRL );
}

void
patchScrollingListClass( void )
{
   struct StringListerClass *class;

   class = ScrollingListClass();
   go_InitBuilderMethods( &ScrollingList_bm );

   ScrollingList_bm.New       = (void *(*)(PObject *))ScrollingList_New;
   ScrollingList_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))ScrollingList_PropEdit;
   ScrollingList_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))ScrollingList_WriteCode;
   ScrollingList_bm.WriteIFF  = ScrollingList_WriteIFF;
   ScrollingList_bm.ReadIFF   = ScrollingList_ReadIFF;

   class->BuilderMethods      = &ScrollingList_bm;
}

