#include <stdlib.h>
#include <string.h>
#include "StringGadget.h"
#include "StringGadgetClass.h"
#include "minmax.h"
#include "EmbossedGadgetClass.h"
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "StringGadget_coder.h"
#include "StringGadget_Builder.h"
#include "StringGadgetIO.h"

/* Changed from StringGadget to void -- EDB */
void *StringGadget_New( StringGadget *self )
{
   StringGadget *new_gadget;
   struct StringInfo *stringinfo;

   if( new_gadget = (StringGadget *)Amalloc( sizeof( StringGadget ) ) )
   {
      if( self )
      {
         stringinfo = (struct StringInfo *)self->g.SpecialInfo;

          StringGadget_Init( new_gadget,
             self->Location.x, self->Location.y,
             self->Size.x, stringinfo->MaxChars-1,
             self->Pens,   Title( (struct GraphicObject *)self ) );
          new_gadget->g.Flags      = self->g.Flags;
          SetStringValue( (Valuator *)new_gadget, StringValue( (Valuator *)self ) );
      }
      else
      {
          StringGadget_Init( new_gadget, 0,0, 64, 40, StandardPens(), NULL );
      }

      GiveItAName( (struct PObject *)new_gadget );

   }
   return new_gadget;
}

long StringGadget_WriteIFF( GraphicObject *self, FILE *file )
{
   return WriteStringGadgetChunk( self, file, STRG );
}

struct BuilderMethods StringGadget_bm;

void
patchStringGadgetClass( void )
{
   struct ValuatorClass *class;

   class = StringGadgetClass();

   class->BuilderMethods = &StringGadget_bm;
   go_InitBuilderMethods( &StringGadget_bm );

   StringGadget_bm.New       = (void *(*)(PObject *))StringGadget_New;
   StringGadget_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))StringGadget_WriteCode;
   StringGadget_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))StringGadget_PropEdit;
   StringGadget_bm.WriteIFF  = StringGadget_WriteIFF;
   StringGadget_bm.ReadIFF   = ReadStringGadgetChunk;

}
