
#include "TitleBox.h"
#include "GraphicObjectClass.h"
#include <stdlib.h>
#include <string.h>
#include "minmax.h"
#include <graphics/gfxmacros.h>

#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "TitleBox_coder.h"
#include "GraphicObjectIO.h"
#include "TitleBoxIO.h"

/* Changed from TitleBox to void -- EDB */
void *TitleBox_New( TitleBox *self )
{
   TitleBox *new_box = NULL;

   if( new_box = Amalloc( sizeof( TitleBox ) ) )
   {
      if( self )
         TitleBox_Init( new_box, self->Location.x, self->Location.y,
            self->Size.x, self->Size.y, self->Pens, Title( (struct GraphicObject *)self ) );
      else
         TitleBox_Init( new_box, 0, 0, 80, 32,  StandardPens(), NULL );

      GiveItAName( (struct PObject *)new_box );
   }

   return new_box;
}

struct BuilderMethods TitleBox_bm;


void
patchTitleBoxClass(void)
{
   struct GraphicObjectClass *class;
   struct GraphicObjectClass *TitleBoxClass( void );

   class = TitleBoxClass();

   go_InitBuilderMethods( &TitleBox_bm );

   TitleBox_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))TitleBox_WriteCode;
   TitleBox_bm.New       = (void *(*)(PObject *))TitleBox_New;
   TitleBox_bm.WriteIFF  = (long(*)(struct GraphicObject *,FILE *))WriteTBoxChunk;
   TitleBox_bm.ReadIFF   = ReadGfxObjChunk;

   class->BuilderMethods = &TitleBox_bm;
}

