/* ==========================================================================
**
**                         VScroller.c
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#include <stdio.h>
#include "minmax.h"
#include "VScroller.h"
#include "VScrollerClass.h"
#include "EmbossedGadgetClass.h"
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "Positioner_Builder.h"
#include "Positioner_coder.h"
#include "PositionerIO.h"

struct BuilderMethods VScroller_bm;

long WriteVScrollerChunk( GraphicObject *obj, FILE* file )
{
   return WritePosrChunk( obj, file, VSCR );
}

/* Changed from VScroller to void -- EDB */
void *VScroller_New( VScroller *self )
{
   VScroller *new_vscroller = NULL;

   if( new_vscroller = (VScroller *)Amalloc( sizeof( VScroller ) ) )
   {
      if( self )
      {
         VScroller_Init( new_vscroller,   self->posr.Location.x,
                         self->posr.Location.y,
                         self->posr.Size.y,    self->Pens,
                         Title( (struct GraphicObject *)self ) );
      }
      else
      {
         VScroller_Init( new_vscroller, 0, 0, 64, StandardPens(), NULL );
      }
      GiveItAName( (struct PObject *)new_vscroller );
   }
   return new_vscroller;
}

void
patchVScrollerClass( void )
{
   struct PositionerClass *class;

   class = VScrollerClass();
   go_InitBuilderMethods( &VScroller_bm );

   VScroller_bm.New       = (void *(*)(PObject *))VScroller_New;
   VScroller_bm.PropEdit  = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))Positioner_PropEdit;
   VScroller_bm.WriteCode = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))Positioner_WriteCode;
   VScroller_bm.WriteIFF  = WriteVScrollerChunk;
   VScroller_bm.ReadIFF   = ReadPosrChunk;

   class->BuilderMethods  = &VScroller_bm;

}
