/* ==========================================================================
**
**                         VSlider.c
** 1991 WILLISoft
**
** ==========================================================================
*/

#include <stdio.h>
#include "minmax.h"
#include "Vslider.h"
#include "VSliderClass.h"
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include "amigamem.h"
#include "BuilderMethods.h"
#include "GraphicObject_Builder.h"
#include "Positioner_Builder.h"
#include "Positioner_Coder.h"
#include "PositionerIO.h"

long WriteVSliderChunk( GraphicObject *obj, FILE* file )
{
   return WritePosrChunk( obj, file, VSLI );
}

/* Changed from Slider to void -- EDB */
void *VSlider_New( VSlider *self )
{
   Slider *new_vslider = NULL;
   Point loc, size;

   if( new_vslider = (VSlider *)Amalloc( sizeof( VSlider ) ) )
   {
      if( self )
      {
         loc  = Location( (struct GraphicObject *)self );
         size = Size( (struct GraphicObject *)self );

         VSlider_Init( new_vslider, loc.x, loc.y, size.x, size.y,
                       self->eg.Pens, Title( (struct GraphicObject *)self ) );
      }
      else
      {
         VSlider_Init( new_vslider, 0, 0, 12, 32, StandardPens(), NULL );
      }

      GiveItAName( (struct PObject *)new_vslider );
   }
   return new_vslider;
}
struct BuilderMethods VSlider_bm;

void
patchVSliderClass( void )
{
   struct PositionerClass *class;

   class = VSliderClass();

   go_InitBuilderMethods( &VSlider_bm );

   VSlider_bm.New        = (void *(*)(PObject *))VSlider_New;
   VSlider_bm.PropEdit   = (void(*)(struct GraphicObject *,struct pcgWindow *,pcg_3DPens))Positioner_PropEdit;
   VSlider_bm.WriteCode  = (void(*)(struct GraphicObject *,struct BuilderWindow *,FILE *,UWORD))Positioner_WriteCode;
   VSlider_bm.WriteIFF   = WriteVSliderChunk;
   VSlider_bm.ReadIFF    = ReadPosrChunk;

   class->BuilderMethods = &VSlider_bm;

}
