/* =====================================================
**   Created by the Precognition Interface Builder
** =====================================================
**
**  Link this file with 'Precognition.o'
**
**  NOTE: The Intuition and Graphics libraries *MUST* be
**  opened before calling this function!
*/

#include "parms.h"
#include "BuilderMethods.h"
#include <string.h>
#include "StringGadget_builder.h"
#include "IntegerGadget.h" /* added for IntegerGadget prototypes -- EDB */
#include "StringGadget.h"
#include "PObject.h"
#include "PObjectClass.h"
#ifndef __GNUC__
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif
#include "amigamem.h"
#include "autocleanup.h"
#include "project.h"

typedef struct StringGadget_PropWindow
{
   pcgWindow      window;
   OutlineBox     OutlineBox3;
   StringGadget   PObjectName;
   StringGadget   Label;
   IntegerGadget  Location_X;
   IntegerGadget  Location_Y;
   IntegerGadget  Width;
   IntegerGadget  n_Chars;
   StringGadget   Initial_Value;
   IntegerGadget  IV2;
   BoolGadget     bg_OK;
   BoolGadget     bg_Cancel;

} StringGadget_PropWindow;

void
sgpw_CleanUp( StringGadget_PropWindow *window )
{
   CleanUp( (struct PObject *)&window->window );
   CleanUp( (struct PObject *)&window->OutlineBox3 );
   CleanUp( (struct PObject *)&window->PObjectName );
   CleanUp( (struct PObject *)&window->Label );
   CleanUp( (struct PObject *)&window->Location_X );
   CleanUp( (struct PObject *)&window->Location_Y );
   CleanUp( (struct PObject *)&window->Width );
   CleanUp( (struct PObject *)&window->n_Chars );
   CleanUp( (struct PObject *)&window->Initial_Value );
   CleanUp( (struct PObject *)&window->IV2 );
   CleanUp( (struct PObject *)&window->bg_OK );
   CleanUp( (struct PObject *)&window->bg_Cancel );
}


char sg_windowtitle[80];

void StringGadget_pw_Init( StringGadget_PropWindow *self,
                           StringGadget            *sg,
                           Screen                  *screen,
                           pcg_3DPens               pens )
{
   /* Initialize the window */
   pcgWindow_Init( &self->window,
      0, 12, 404, 168, 1, 1, (USHORT)-1, (USHORT)-1, /* LeftEdge, TopEdge, Width, Height */
      NULL, /* title */
      REFRESHWINDOW | MENUPICK | CLOSEWINDOW | MENUVERIFY, /* IDCMPFlags */
      WINDOWDRAG | WINDOWDEPTH | WINDOWCLOSE | SIMPLE_REFRESH | ACTIVATE, /* Flags */
      screen ); /* pointer to screen */

   OutlineBox_Init( &self->OutlineBox3,
      12, 56, 380, 88, /* LeftEdge, TopEdge, Width, Height */
      pens, " Dimensions " );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->OutlineBox3 );

   StringGadget_Init( &self->PObjectName,
      128, 20, 248, /* LeftEdge, TopEdge, Width */
      80, /* # of characters */
      pens, "Variable Name:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->PObjectName );

   StringGadget_Init( &self->Label,
      128, 36, 248, /* LeftEdge, TopEdge, Width */
      80, /* # of characters */
      pens, "Label:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->Label );

   IntegerGadget_Init( &self->Location_X,
      128, 68, 48, /* LeftEdge, TopEdge, Width */
      10, /* # of characters */
      pens, "Location X:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->Location_X );

   IntegerGadget_Init( &self->Location_Y,
      212, 68, 48, /* LeftEdge, TopEdge, Width */
      10, /* # of characters */
      pens, "Y:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->Location_Y );

   IntegerGadget_Init( &self->Width,
      328, 68, 48, /* LeftEdge, TopEdge, Width */
      10, /* # of characters */
      pens, "Width:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->Width );

   IntegerGadget_Init( &self->n_Chars,
      212, 88, 48, /* LeftEdge, TopEdge, Width */
      10, /* # of characters */
      pens, "Number of Characters:" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->n_Chars );

   StringGadget_Init( &self->Initial_Value,
      212, 104, 164, /* LeftEdge, TopEdge, Width */
      256, /* # of characters */
      pens, "Initial Value (string):" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->Initial_Value );

   IntegerGadget_Init( &self->IV2,
      212, 120, 48, /* LeftEdge, TopEdge, Width */
      11, /* # of characters */
      pens, "Initial Value (integer):" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->IV2 );


   BoolGadget_Init( &self->bg_OK,
      12, 148, 96, 14, /* LeftEdge, TopEdge, Width, Height */
      pens, "  OK" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->bg_OK );

   BoolGadget_Init( &self->bg_Cancel,
      296, 148, 96, 14, /* LeftEdge, TopEdge, Width, Height */
      pens, " CANCEL" );
   AddWindowPObject( &self->window, (struct GraphicObject *)&self->bg_Cancel );

}

void StringGadget_SetSettings( StringGadget *self, StringGadget_PropWindow *w )
{
   Point location, size;
   struct StringInfo *stringinfo;

   memset( sg_windowtitle, 0 ,80 );
   strcat( sg_windowtitle, ClassName( (struct PObject *)self ) );
   strcat( sg_windowtitle, " Properties" );
   SetTitle( (struct GraphicObject *)&w->window, sg_windowtitle );


   stringinfo = (struct StringInfo*) self->g.SpecialInfo;

   SetStringValue( (Valuator *)&w->Label, Title( (struct GraphicObject *)self ) );
   SetStringValue( (Valuator *)&w->PObjectName, self->PObjectName );

   size     = Size( (struct GraphicObject *)self );
   location = Location( (struct GraphicObject *)self );
   SetValue( (Valuator *)&w->Location_X,  location.x );
   SetValue( (Valuator *)&w->Location_Y,   location.y );
   SetValue( (Valuator *)&w->Width,     size.x );
   SetValue( (Valuator *)&w->n_Chars,   stringinfo->MaxChars-1 );

   if( isa( (struct PObject *)self, IntegerGadgetClass() ) )
   {
      SetValue( (Valuator *)&w->IV2, Value( (Valuator *)self ) );
      SetStringValue( (Valuator *)&w->Initial_Value,  NULL );
   }
   else
   {
      SetValue( (Valuator *)&w->IV2, 0 );
      SetStringValue( (Valuator *)&w->Initial_Value,  StringValue( (Valuator *)self )  );
   }
}

void StringGadget_PutSettings( StringGadget *self, StringGadget_PropWindow *w )
{
   Point location, size;
   struct StringInfo *stringinfo;
   short n_chars;

   stringinfo = (struct StringInfo *)self->g.SpecialInfo;

   SetObjectName( (struct PObject *)self, StringValue( (Valuator *)&w->PObjectName ) );
   SetTitle( (struct GraphicObject *)self, (char *)StringValue( (Valuator *)&w->Label ) );

   size       = Size( (struct GraphicObject *)self );
   location.x = Value( (Valuator *)&w->Location_X );
   location.y = Value( (Valuator *)&w->Location_Y );
   size.x     = Value( (Valuator *)&w->Width      );
   SetLocation( (struct GraphicObject *)self, location.x, location.y );
   SetSize( (struct GraphicObject *)self, size.x, size.y );

   n_chars = Value( (Valuator *)&w->n_Chars );
   Afree( stringinfo->Buffer );
   stringinfo->MaxChars   = n_chars+1;
   stringinfo->Buffer     = Acalloc( 1, n_chars +1 );

   if( isa( (struct PObject *)self, IntegerGadgetClass() ) )
      SetValue( (Valuator *)self, Value( (Valuator *)&w->IV2 ) );
   else
      SetStringValue( (Valuator *)self, StringValue( (Valuator *)&w->Initial_Value ) );

   Project_Modify();
}


StringGadget_PropWindow StringGadget_Inspector;
BOOL sg_PropWindow_Initialized = FALSE;

void StringGadget_PropEdit(   StringGadget  *self,
                              pcgWindow     *window,
                              pcg_3DPens     pens )
{

   BOOL done;
   IntuiMessage *message, event;

   if( ! sg_PropWindow_Initialized )
   {
      StringGadget_pw_Init( &StringGadget_Inspector, self,
         window->Window->WScreen, pens );

      StringGadget_Inspector.window.SharedUserPort =
         window->SharedUserPort;

      sg_PropWindow_Initialized = TRUE;

      RegisterCleanUp( (ptr2func)sgpw_CleanUp, &StringGadget_Inspector );
   }

   if( isa( (struct PObject *)self, IntegerGadgetClass() ) )
   {
      EnableIactor( (struct Interactor *)&StringGadget_Inspector.IV2,           TRUE );
      EnableIactor( (struct Interactor *)&StringGadget_Inspector.Initial_Value, FALSE );
   }
   else
   {
      EnableIactor( (struct Interactor *)&StringGadget_Inspector.IV2,           FALSE );
      EnableIactor( (struct Interactor *)&StringGadget_Inspector.Initial_Value, TRUE );
   }

   StringGadget_SetSettings( self, &StringGadget_Inspector );


   /*  Open the window (returns NULL on failure) */
   if( pcgOpenWindow( &StringGadget_Inspector.window ) )
   {
      Refresh( (struct Interactor *)&StringGadget_Inspector.window ); /* Draw the window graphics. */
      Activate( (struct Interactor *)&StringGadget_Inspector.PObjectName, TRUE );

      done = FALSE;
      while( !done ) /* Main event loop */
      {
         message = (IntuiMessage *)GetMsg( StringGadget_Inspector.window.Window->UserPort );
         if( message == NULL )
         { /* No message is waiting, wait for one... */
             WaitPort( StringGadget_Inspector.window.Window->UserPort );
             continue;
         }
         event = *message; /* Make a local copy of the message */
         ReplyMsg( (struct Message *)message );

         switch( event.Class )
         {

            case CLOSEWINDOW:
               done = TRUE; /* exit the loop.  */
               break;

            case REFRESHWINDOW:
               {
                  pcgWindow *some_window;

                  some_window = (pcgWindow *)event.IDCMPWindow->UserData;
                  BeginRefresh( event.IDCMPWindow );
                  Refresh( (struct Interactor *)some_window );
                  EndRefresh( event.IDCMPWindow, TRUE );
               }
               break;

            default:
               if( Respond( (struct Interactor *)&StringGadget_Inspector.PObjectName, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.PObjectName );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.Label, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.Label );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.Location_X, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.Location_X );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.Location_Y, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.Location_Y );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.Width, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.Width );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.n_Chars, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.n_Chars );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.Initial_Value, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.Initial_Value );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.IV2, &event ) &
                            ( CHANGED_STATE | DEACTIVATED ) )
               {
                  /* Activate next string or integer gadget. */
                  ActivateNext( (struct Interactor *)&StringGadget_Inspector.IV2 );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.bg_OK, &event ) & CHANGED_STATE )
               { /* bg_OK was hit. */
                  done = TRUE;

                  StringGadget_PutSettings( self, &StringGadget_Inspector );
               }

               if( Respond( (struct Interactor *)&StringGadget_Inspector.bg_Cancel, &event ) & CHANGED_STATE )
               { /* bg_Cancel was hit. */
                  done = TRUE;
               }

         } /* end switch */

      } /* end loop */

      pcgCloseWindow( &StringGadget_Inspector.window );
   } /* end if */

   else /* Window could not be opened. */
   {
      ; /*** YOUR ERROR HANDLING HERE ***/
   }

}
