#include <stdio.h>
#include "StringGadget_coder.h"
#include "CodeWriter.h"

#define FP fprintf( file,
/* #define FP printf(  */


void StringGadget_WriteCode(  StringGadget  *self,
                              BuilderWindow *bw,
                              FILE          *file,
                              UWORD          section )
{
   char             *name, *title, *value;
   Point             size, location;
   struct StringInfo *stringinfo;

   name = PObjectName( (struct PObject *)self );

  /* printf("Write Code for %s\n", ClassName(self) ); */


   switch( section )
   {
      case CODE_MIDDLE_WSTRUCT:
         FP "   StringGadget\t\t%s;\n", name );
         break;

      case CODE_CTOR_BODY:
         location = Location( (struct GraphicObject *)self );
         size     = Size( (struct GraphicObject *)self );
         title    = Title( (struct GraphicObject *)self );
         stringinfo = (struct StringInfo *)self->g.SpecialInfo;
         FP "   StringGadget_Init( &window->%s,\n", name );
         FP "      %d, %d, %d, /* LeftEdge, TopEdge, Width */\n",
            location.x, location.y, size.x );
         FP "      %d, /* # of characters */\n", stringinfo->MaxChars-1 );
         FP "      pens, ");
         if( title )
            FP "\"%s\" );\n", title );
         else
            FP "NULL );\n" );

         value = StringValue( (Valuator *)self );
         if( ( value != NULL ) && ( value[0] != '\0' ) )
            FP "   SetStringValue( (Valuator *)&window->%s, \"%s\" );\n", name, value );

         FP "   AddWindowPObject( &window->w, (struct GraphicObject *)&window->%s );\n\n",
               name );
         break;

      case CODE_DEFAULT_EVENT:
         FP "            r = Respond( (struct Interactor *)&window->%s, event );\n", name );
         FP "            if( r & ( CHANGED_STATE | DEACTIVATED ) )\n" );
         FP "            {  /* User entered something into %s \n", name );
         FP "               ** To get the string value of the gadget, use:\n");
         FP "               **       char *value;\n");
         FP "               **       value = StringValue( (Valuator *)&window->%s );\n", name );
         FP "               **\n");
         FP "               ** To set the value, use:\n");
         FP "               **       SetStringValue( (Valuator *)&window->%s, value );\n", name );
         FP "               */\n");
         FP "               ; /* YOUR CODE HERE */\n");
         FP "               /* Activate next string or integer gadget. */\n" );
         FP "               response |= r;\n");
         FP "               ActivateNext( (struct Interactor *)&window->%s );\n", name );
         FP "            }\n\n");
         break;

      case CODE_DTOR_BODY:
         FP "   CleanUp( (struct PObject *)&window->%s );\n", name );
         break;

   }
}
