
#include "stringlistio.h"
#include "AmigaMem.h"
#include <string.h>

long WriteCHRSchunk( FILE* file, char *string )
{
   long beginkey, status;

   status = beginkey = IFF_BeginChunk ( file, CHRS );

   if( status >= 0 )
   {
      fwrite( string, strlen(string), 1, file );
      IFF_EndChunk( file, beginkey );
   }

   return status;
}

long WriteStringList( FILE* file, struct StringList *slist )
{
   long beginkey, status;
   int i;

   status = beginkey = IFF_BeginGroupChunk( file, LIST, CHRS );

   if( status >= 0 )
   {
      for( i = 0; i < slist->nEntries; i++ )
      {
         WriteCHRSchunk( file, slist->Entries[i] );
      }

      IFF_EndChunk( file, beginkey );
   }

   return status;
}


long ReadCHRSchunk( FILE   *file,
                    struct ChunkInfo *chunk,
                    struct StringList *slist )
{
   long status;
   char *buffer = Amalloc( chunk->length +1 );

   status = fread( buffer, chunk->length, 1, file );
   StringList_AddString( slist, buffer, 0 );

   Afree( buffer );
   return status;
}

long ReadStringList( FILE* file,
                     struct ChunkInfo *chunk,
                     struct StringList *slist )
{
   struct ChunkInfo subchunk;
   long status, pos;

   for(;;)
   {
      status = pos = ftell( file );
      if( status < 0 ) break;

      if( pos >= chunk->end ) break;

      status = IFF_ReadChunkInfo( file, &subchunk );
      if( status < 0 ) break;

      if( subchunk.Id == CHRS )
         ReadCHRSchunk( file, &subchunk, slist );

      /* seek to next chunk */
      fseek( file, subchunk.next, SEEK_SET );
   }

   return status;
}

