#ifndef BUILDERWINDOW_H
#define BUILDERWINDOW_H

#include "Precognition3D.h"
#include "pcgWindow.h"
#include "pcgWindowClass.h"
#include "GridSnap.h"
/* #include "EditBox.h"  */
#include "Editor.h"

typedef struct BuilderWindow
{
   pcgWindow      pw;
   Editor         eb;
   ULONG          IDCMPFlags;
} BuilderWindow;

/* a builder window is just like a normal window, except that
 * gadgets never get added to it.
 */

struct pcgWindowClass *BuilderWindowClass( void );

void BuilderWindowClass_Init( struct pcgWindowClass *class );

void BuilderWindow_Init( BuilderWindow     *self,
                         UWORD              leftedge,
                         UWORD              topedge,
                         UWORD              width,
                         UWORD              height,
                         pcg_3DPens         pens,
                         char              *title,
                         struct Screen     *screen,
                         GridInfo          *gridinfo );


void BuilderWindow_AddPObject( BuilderWindow  *self,
                              GraphicObject  *obj );

void BuilderWindow_PObjectToFront( BuilderWindow *self,
                                  GraphicObject *obj );

void BuilderWindow_PObjectToBack( BuilderWindow *self,
                                 GraphicObject *obj );

   /* These 3 work for both GraphicObjects and Interactors. */

GraphicObject *BuilderWindow_FindPObject( BuilderWindow *self,
                                         Point          coord );

#endif
