#ifndef CLIPPEDIMAGERASTPORT_H
#define CLIPPEDIMAGERASTPORT_H

#include <exec/types.h>
#include <graphics/clip.h>
#include <graphics/gfx.h>
#include <graphics/layers.h>
#include <graphics/rastport.h>
#include <intuition/intuition.h>

typedef struct ClippedImageRastPort
{
   struct BitMap        bitmap;
   struct RastPort     *rastport;
   struct Layer        *layer;
   struct Layer_Info   *layerinfo;
} ClippedImageRastPort;

 /* Changed from struct LayerInfo -- EDB */

BOOL ClippedImageRastPort_Init( struct ClippedImageRastPort *cirp,
                                struct Image                *image );
/*
** Initializes a 'ClipeedImageRastPort' struct.  After successful
** completion, you can draw into the image using 'cirp->rastport'
** as the RastPort.
**
** Returns FALSE on error.
**
** The following libraries MUST be open:
**
**    *  layers.library
**    *  graphics.library
**
*/


void ClippedImageRastPort_CleanUp( struct ClippedImageRastPort *cirp );
/*
** This should be called when you are done with a 'ClippedImageRastPort'
** structure.  It deallocates the Layer and LayerInfo data that was
** allocated by 'ClippedImageRastPort_Init()'.
*/

#endif

