#ifndef EDITOR_H
#define EDITOR_H

#include "Interactor.h"
#include "InteractorClass.h"
#include "Precognition3d.h"
#include "GridSnap.h"
#include "SelectedObject.h"
#include "array.h"

/* PObject<GraphicObject<Interactor<Editor
 */



typedef struct LastClick              /* Info on the last object clicked. */
{                             /* (used for double click detection.) */
      GraphicObject  *object;
      LONG            Seconds;
      LONG            Micros;
} LastClick;



typedef struct EditBox
   {
      /* -- Interactor --------------*/
      PClass             *isa;
      char              *PObjectName;
      void              *Next;
      struct pcgWindow  *IaWindow;
      Point              Location;
      Point              Size;

      /* -- New Stuff -------------*/
      USHORT             state;
      USHORT             substate;
      Point              Handle;         /* Where the mouse grabs it. */
      Point              Delta;
      ULONG              IDCMPBuf;
      struct LastClick   lastclick,
                         prevclick;
      pcg_3DPens         pens;    /* needed to create/edit other objects. */

      SelectedObject    *FirstSelection;
      USHORT             nSelected; /* # of objects selected. */

      GraphicObject     *Target; /* the last object selected. */
      GridInfo          *gridinfo;
      Array             *pasteBuffer;
} Editor;

/*------- EditBox states --------------*/

#define EDITOR_WAITING  0
#define EDITOR_LASSOING 1
#define EDITOR_DRAGGING 2
#define EDITOR_SIZING   3

/*------------------- HitClasses ------------*/
typedef USHORT HitClass;

#define NONE       0
#define LEFTHIT    1
#define RIGHTHIT   2
#define TOPHIT     4
#define BOTTOMHIT  8
#define CENTERHIT  16

#define LEFTTOPHIT     LEFTHIT    | TOPHIT
#define RIGHTTOPHIT    RIGHTHIT   | TOPHIT
#define LEFTBOTTOMHIT  LEFTHIT    | BOTTOMHIT
#define RIGHTBOTTOMHIT RIGHTHIT   | BOTTOMHIT

typedef struct HitInfo
{
   HitClass       hitclass;
   GraphicObject *PObject;
} HitInfo;


void Editor_Init( Editor *self, pcg_3DPens pens, GridInfo *gridinfo );
struct InteractorClass *EditorClass( void );


HitClass ClassifyHit( GraphicObject *self, Point coord );

HitInfo FindHitPObject( GraphicObject *first, Point coord );

HitInfo FindHitSelection( SelectedObject *first, Point coord );

#endif
