#define MENUSTUFF_BODY

#include <string.h>
#include <ctype.h>
#include "intuition_typedefs.h"
#include "precognition_utils.h"
#include "pcg_Menus.h"
#include "minmax.h"
#include "menustuff.h"
#ifndef __GNUC__
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#endif

#include "amigamem.h"

#define WIDTH_OF_AMIGA_KEY 40
    /* Extra width required for shortcut graphic */


void mnu_InitItem( pcg_TextMenuItem *item,
                   char             *text,
                   char              command,
                   USHORT            ID );


static pcg_SeprMenuItem *divider;

void mnu_InitItem( pcg_TextMenuItem *item,
                   char             *text,
                   char              command,
                   USHORT            ID )
{

   pcg_InitTextMenuItem( item, text, strlen(text), &pcg_Topaz80,
            WIDTH_OF_FONT, HEIGHT_OF_FONT );

   if (command)
   {
      item->Flags   |= COMMSEQ;
      item->Command  = command;
      item->Width   += WIDTH_OF_AMIGA_KEY;
   }

   item->ItemID    = ID;
}



Menu *mnu_BuildProjectMenu( void )
{
   /* EDB -- added 'N' to be more style guide compliant */
   mnu_InitItem( &mi_New, "New", 'N', PROJECT_NEW_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_New );

   mnu_InitItem( &mi_Open, "Open...", 'O', PROJECT_OPEN_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_Open );

   mnu_InitItem( &mi_Save, "Save...", 'S', PROJECT_SAVE_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_Save );

   mnu_InitItem( &mi_Save_As, "Save As...", 'A', PROJECT_SAVE_AS_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_Save_As );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_Code, "Write Code...", '\0', PROJECT_CODE_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_Code );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_About, "About...", '\0', PROJECT_ABOUT_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_About );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_Quit, "Quit", 'Q', PROJECT_QUIT_ID );
   pcg_AppendMenuItem( &ProjectMenu, (struct pcg_MenuItem *)&mi_Quit );

   pcg_StackItems         ( (pcg_MenuItem*) ProjectMenu.FirstItem, 0, TRUE  );
   pcg_TidyUpItemWidths   ( (pcg_MenuItem*) ProjectMenu.FirstItem           );
   pcg_TidyUpItemLeftEdges( (pcg_MenuItem*) ProjectMenu.FirstItem, 0, 400   );

   return &ProjectMenu;
}

Menu *mnu_BuildEditMenu( void )
{

   mnu_InitItem( &mi_Copy, "Copy", 'C', EDIT_COPY_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Copy );

   mnu_InitItem( &mi_Cut, "Cut", 'X', EDIT_CUT_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Cut );

   mnu_InitItem( &mi_Paste, "Paste", 'V', EDIT_PASTE_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Paste );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_Front, "Front", 'F', EDIT_FRONT_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Front );

   mnu_InitItem( &mi_Back, "Back", 'Z', EDIT_BACK_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Back );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)divider );

/*
   mnu_InitItem( &mi_Group, "Group", 'G', EDIT_GROUP_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Group );

   mnu_InitItem( &mi_Ungroup, "UnGroup", 'U', EDIT_UNGROUP_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Ungroup );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)divider );
*/

   mnu_InitItem( &mi_Alignment, "Alignment             ", 0, 0 );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Alignment );

      mnu_InitItem( &mi_Align_Left, "Left", 'L', ALIGN_LEFT_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_Left );

      mnu_InitItem( &mi_Align_Right, "Right", 'R', ALIGN_RIGHT_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_Right );

      mnu_InitItem( &mi_Align_CenterX, "Center X", 0, ALIGN_CENTERX_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_CenterX );

      divider = pcg_NewSeprMenuItem();
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)divider );

      mnu_InitItem( &mi_Align_Top, "Top", 'T', ALIGN_TOP_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_Top );

      mnu_InitItem( &mi_Align_Bottom, "Bottom", 'B', ALIGN_BOTTOM_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_Bottom );

      mnu_InitItem( &mi_Align_CenterY, "Center Y", 0, ALIGN_CENTERY_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Alignment, (struct pcg_MenuItem *)&mi_Align_CenterY );


   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_Props, "Object Props/Info", 'I', EDIT_PROPS_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Props );

   mnu_InitItem( &mi_Window_Props, "Window Properties", 'W', EDIT_WINDOW_ID );
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)&mi_Window_Props );

   divider = pcg_NewSeprMenuItem();
   pcg_AppendMenuItem( &EditMenu, (struct pcg_MenuItem *)divider );

   mnu_InitItem( &mi_Grid,   "Grid Snap             ", '\0', 0 );
   pcg_AppendMenuItem( &EditMenu,  (struct pcg_MenuItem *)&mi_Grid );

      mnu_InitItem( &mi_Grid_Control, "Grid Controls", 'H', EDIT_GRID_ID );
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Grid,  (struct pcg_MenuItem *)&mi_Grid_Control );

      mnu_InitItem( &mi_Grid_Loc, "   Location Snap", 'J', EDIT_GRID_LOC_ID );
      mi_Grid_Loc.Flags |= CHECKIT | CHECKED | MENUTOGGLE;
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Grid, (struct pcg_MenuItem *)&mi_Grid_Loc );

      mnu_InitItem( &mi_Grid_Size, "   Size Snap", 'K', EDIT_GRID_SIZ_ID );
      mi_Grid_Size.Flags |= CHECKIT | CHECKED | MENUTOGGLE;
      pcg_AppendMenuSubItem( (struct pcg_MenuItem *)&mi_Grid,  (struct pcg_MenuItem *)&mi_Grid_Size );


   pcg_StackItems         ( (pcg_MenuItem*) EditMenu.FirstItem, 0, TRUE  );
   pcg_TidyUpItemWidths   ( (pcg_MenuItem*) EditMenu.FirstItem           );
   pcg_TidyUpItemLeftEdges( (pcg_MenuItem*) EditMenu.FirstItem, 0, 400   );

   return &EditMenu;
}


void mnu_SetCheckMark( pcg_MenuItem *item, BOOL Checked )
{
   if (Checked)
      item->Flags |= CHECKED;
   else
      item->Flags &= ~CHECKED;
}


Menu *mnu_BuildMenus( void )
{
   Menu *FirstMenu = NULL;

   /* printf("BuildMenus\n");  */

   pcg_AppendMenu( &FirstMenu, mnu_BuildProjectMenu() );

   /* printf("After Project menu\n"); */

   pcg_AppendMenu( &FirstMenu, mnu_BuildEditMenu()    );
   /* printf("After Edit menu\n"); */


   mn_Project        = pcg_MenuNumber_of( FirstMenu,  &ProjectMenu );
   mn_New            = pcg_MenuNumber_of( FirstMenu,  &mi_New );
   mn_Open           = pcg_MenuNumber_of( FirstMenu,  &mi_Open );
   mn_Save           = pcg_MenuNumber_of( FirstMenu,  &mi_Save );
   mn_Save_As        = pcg_MenuNumber_of( FirstMenu,  &mi_Save_As );
   mn_About          = pcg_MenuNumber_of( FirstMenu,  &mi_About );
   mn_Code           = pcg_MenuNumber_of( FirstMenu,  &mi_Code );
   mn_div0           = pcg_MenuNumber_of( FirstMenu,  &mi_div0 );
   mn_Quit           = pcg_MenuNumber_of( FirstMenu,  &mi_Quit );

   mn_Edit           = pcg_MenuNumber_of( FirstMenu,  &EditMenu );
   mn_Cut            = pcg_MenuNumber_of( FirstMenu,  &mi_Cut );
   mn_Copy           = pcg_MenuNumber_of( FirstMenu,  &mi_Copy );
   mn_Paste          = pcg_MenuNumber_of( FirstMenu,  &mi_Paste );
   mn_div1           = pcg_MenuNumber_of( FirstMenu,  &mi_div1 );
   mn_Front          = pcg_MenuNumber_of( FirstMenu,  &mi_Front );
   mn_Back           = pcg_MenuNumber_of( FirstMenu,  &mi_Back );
   mn_div3           = pcg_MenuNumber_of( FirstMenu,  &mi_div3 );

   mn_Group          = pcg_MenuNumber_of( FirstMenu, &mi_Group );
   mn_Ungroup        = pcg_MenuNumber_of( FirstMenu, &mi_Ungroup );
   mn_div6           = pcg_MenuNumber_of( FirstMenu, &mi_div6 );

   mn_Alignment      = pcg_MenuNumber_of( FirstMenu, &mi_Alignment );
   mn_Align_Left     = pcg_MenuNumber_of( FirstMenu, &mi_Align_Left );
   mn_Align_Right    = pcg_MenuNumber_of( FirstMenu, &mi_Align_Right );
   mn_Align_CenterX  = pcg_MenuNumber_of( FirstMenu, &mi_Align_CenterX );
   mn_div4           = pcg_MenuNumber_of( FirstMenu, &mi_div4 );
   mn_Align_Top      = pcg_MenuNumber_of( FirstMenu, &mi_Align_Top );
   mn_Align_Bottom   = pcg_MenuNumber_of( FirstMenu, &mi_Align_Bottom );
   mn_Align_CenterY  = pcg_MenuNumber_of( FirstMenu, &mi_Align_CenterY );
   mn_div5           = pcg_MenuNumber_of( FirstMenu, &mi_div5 );

   mn_Props          = pcg_MenuNumber_of( FirstMenu,  &mi_Props );
   mn_Window_Props   = pcg_MenuNumber_of( FirstMenu,  &mi_Window_Props );
   mn_div2           = pcg_MenuNumber_of( FirstMenu,  &mi_div2 );
   mn_Grid           = pcg_MenuNumber_of( FirstMenu,  &mi_Grid );
   mn_Grid_Control   = pcg_MenuNumber_of( FirstMenu,  &mi_Grid_Control );
   mn_Grid_Loc       = pcg_MenuNumber_of( FirstMenu,  &mi_Grid_Loc );
   mn_Grid_Size      = pcg_MenuNumber_of( FirstMenu,  &mi_Grid_Size );

   /* printf("After menu numbers\n"); */

   return FirstMenu;
}


