#ifndef MENUSTUFF_H
#define MENUSTUFF_H

#include <exec/types.h>
#include <intuition/intuition.h>
#include "pcg_Menus.h"


#define PROJECT_NEW_ID     100
#define PROJECT_OPEN_ID    101
#define PROJECT_SAVE_ID    102
#define PROJECT_SAVE_AS_ID 103
#define PROJECT_QUIT_ID    104
#define PROJECT_CODE_ID    105
#define PROJECT_ABOUT_ID   106

#define EDIT_CUT_ID        200
#define EDIT_COPY_ID       201
#define EDIT_PASTE_ID      202
#define EDIT_PROPS_ID      203
#define EDIT_GRID_ID       204
#define EDIT_GRID_LOC_ID   206
#define EDIT_GRID_SIZ_ID   207
#define EDIT_WINDOW_ID     205
#define EDIT_FRONT_ID      208
#define EDIT_BACK_ID       209
#define EDIT_GROUP_ID      210
#define EDIT_UNGROUP_ID    211

#define ALIGNMENT_ID       250
#define ALIGN_LEFT_ID      251
#define ALIGN_RIGHT_ID     252
#define ALIGN_TOP_ID       253
#define ALIGN_BOTTOM_ID    254
#define ALIGN_CENTERX_ID   255
#define ALIGN_CENTERY_ID   256

struct Menu *mnu_BuildMenus( void );

void mnu_SetCheckMark( pcg_MenuItem *item, BOOL Checked );

#ifdef MENUSTUFF_BODY
#define EXTERN /**/
Menu ProjectMenu =
{
   NULL, 
   10, 0,       /* LeftEdge, TopEdge */
   8*WIDTH_OF_FONT, HEIGHT_OF_FONT,      /* Width,    Height */
   MENUENABLED, 
   "Project", 
   NULL 
};

Menu EditMenu =
{
   NULL, 
   10, 0,       /* LeftEdge, TopEdge */
   5*WIDTH_OF_FONT, HEIGHT_OF_FONT,      /* Width,    Height */
   MENUENABLED, 
   "Edit", 
   NULL 
};

#else
#define EXTERN extern
extern Menu ProjectMenu, EditMenu;
#endif




EXTERN pcg_TextMenuItem 
   mi_New, 
   mi_Open, 
   mi_Save, 
   mi_Save_As, 
   mi_div00, /* divider */
   mi_Code,
   mi_div01, /* divider */
   mi_About,
   mi_div0, /* divider */
   mi_Quit, 
   
   mi_Cut,
   mi_Copy,
   mi_Paste,
   mi_div1, /* divider */
   mi_Front,
   mi_Back,
   mi_div3,

   mi_Group,
   mi_Ungroup,
   mi_div6,
   
   mi_Alignment,
      mi_Align_Left,
      mi_Align_Right,
      mi_Align_CenterX,
      mi_div4,
      mi_Align_Top,
      mi_Align_Bottom,
      mi_Align_CenterY,
      
   mi_div5,   
   mi_Props,
   mi_Window_Props,
   mi_div2, /* divider */
   mi_Grid,
      mi_Grid_Control,
      mi_Grid_Loc,
      mi_Grid_Size;

EXTERN UWORD /* These are the menu numbers for these items. */
   mn_Project,
   mn_New, 
   mn_Open, 
   mn_Save, 
   mn_Save_As, 
   mn_Code,
   mn_About,
   mn_div0, /* divider */
   mn_Quit, 
   
   mn_Edit,
   mn_Cut,
   mn_Copy,
   mn_Paste,
   mn_div1, /* divider */
   mn_Front,
   mn_Back,
   mn_div3,
   mn_Group,
   mn_Ungroup,
   mn_div6,   
   mn_Alignment,
      mn_Align_Left,
      mn_Align_Right,
      mn_Align_CenterX,
      mn_div4,
      mn_Align_Top,
      mn_Align_Bottom,
      mn_Align_CenterY,
      
   mn_div5,   
   mn_Props,
   mn_Window_Props,
   mn_div2, /* divider */
   mn_Grid,
      mn_Grid_Control,
      mn_Grid_Loc,
      mn_Grid_Size;

#endif
