#include "pcgPrefs.h"
#include <exec/types.h>
#include <workbench/startup.h>
#include <libraries/dos.h>
#include <workbench/workbench.h>
#ifndef __GNUC__
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/dos_protos.h>
#include <clib/wb_protos.h>
#include <clib/icon_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/dos.h>
#include <proto/wb.h>
#include <proto/icon.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/dos.h>
#include <proto/wb.h>
#include <proto/icon.h> /* Added for icon.library prototypes -- EDB */
#endif

#include "amigamem.h"
#include <stdio.h>
#include <string.h> /* added for strcpy() prototype -- EDB */

BPTR prev_dir;

void RestorePrevDir( void )
{
   if( prev_dir )
      CurrentDir( prev_dir );
}

void ParseToolTypes( struct WBArg          *wbarg,
                     struct pcgPreferences *prefs )
{
   struct DiskObject *disk_object;
   char              *filename;
   char             **toolarray;
   char              *tool;

   filename = wbarg->wa_Name;

   if( ( filename[0] ) && ( disk_object = GetDiskObject( filename ) ) )
   {
      toolarray = (char **)disk_object->do_ToolTypes;

      if( tool = (char *)FindToolType( (UBYTE **)toolarray, "INTERLACE" ) )
      {
         if( MatchToolValue( tool, "YES" ) )
            prefs->Interlace = YES;

         if( MatchToolValue( tool, "NO" ) )
            prefs->Interlace = NO;
      }

      FreeDiskObject( disk_object );
   }
}

extern char *proj_filename;
extern char  proj_file[];


void pcgGetPrefs( int                     argc,
                  char                  **argv,
                  struct pcgPreferences  *prefs )

{
   struct WBStartup *startup_message;
   struct WBArg     *wb_arg;
   int i;


   if( argc == 0 )
   {
      startup_message = (struct WBStartup *)argv;
      wb_arg          = startup_message->sm_ArgList;

      for( i = 0; i < startup_message->sm_NumArgs; i++, wb_arg++ )
      {
         ParseToolTypes( wb_arg, prefs );
      }

      if( startup_message->sm_NumArgs >= 2 )
      {
         wb_arg = startup_message->sm_ArgList;
         wb_arg++;

         if( wb_arg->wa_Lock != NULL )
         {
            prev_dir = CurrentDir( wb_arg->wa_Lock );
         }

         proj_filename = strcpy( proj_file, wb_arg->wa_Name );
      }

   }
   else /* Parse command line arguements. */
   {

      if( argc > 2 )
      {
         fprintf( stderr, "USAGE: builder [file]\n");
      }
      else if( argc == 2 )
      {
         proj_filename = strcpy( proj_file, argv[1] );
      }

   }

   if( prefs->Interlace == DONT_KNOW )
      /* set it equal to the resolution of the workbench screen. */
   {
      struct Preferences workbench_prefs;

      GetPrefs( &workbench_prefs, sizeof( struct Preferences ) );

      prefs->Interlace = ( workbench_prefs.LaceWB ) ? YES : NO;
   }

}

