#ifndef TOOLWINDOW_H
#define TOOLWINDOW_H

#include "Precognition3D.h"
#include "pcgWindow.h"
#include "pcgWindowClass.h"

#include "GelsSystem.h"
#include "ImageBob.h"


#include "TitleBox.h"
#include "OutlineBox.h"
#include "ToolButton.h"
#include "ClippedImageRastPort.h"

typedef struct ToolWindow
{
   pcgWindow            pw;

   GelsSystem              gelssystem;
   ImageBob                ibob;
   RastPort               *GelsRPort;
   struct ViewPort        *GelsVPort;

   ToolButton             *selected_button;
   GraphicObject          *archetype;

   short                   y;
   short                   state;
   ULONG                   IDCMPbuf;
   pcg_3DPens              pens;

   void                   *builder; /* pointer to the builder window. */
   Point                   offset;
   Point                   dragback; /* Where image-bob returns to */
} ToolWindow;
      /* A tool a window is type of a pcgWindow. */

void ToolWindow_Init( ToolWindow     *self,
                      USHORT          leftedge,
                      USHORT          topedge,
                      Screen         *screen,
                      struct MsgPort *SharedPort,
                      pcg_3DPens      pens,
                      char           *title );


void ToolWindow_AddArchetype( ToolWindow     *self,
                              GraphicObject  *archetype );


#endif
