#include <exec/types.h>
#include <exec/memory.h>
#ifndef __GNUC__
#include <clib/exec_protos.h>
#endif
#ifdef __GNUC__
#include <proto/exec.h>
#endif
#ifdef __SASC
#include <proto/exec.h>
#endif
#include "funclists.h"


#define NEWNODE ( (struct FuncNode *)AllocMem( sizeof( struct FuncNode ), MEMF_CLEAR ) )
#define FREENODE(n) FreeMem( n, sizeof( struct FuncNode ) )


struct FuncNode*
AllocFuncNode( ptr2func func, void* userdata )
{
   struct FuncNode *node;

   if( ( node = NEWNODE ) != NULL )
   {
      node->func     = func;
      node->UserData = userdata;
   }

   return node;
}

void
FreeFuncNode( struct FuncNode* node )
{
   FREENODE( node );
}


struct FuncNode*
PushFunc( struct MinList *list, ptr2func func, void* userdata )
{
   struct FuncNode *node;

   if( ( node = AllocFuncNode( func, userdata ) ) != NULL )
   {
      AddHead( (struct List *)list, (struct Node *)node );
   }
   return node;
}


struct FuncNode*
QueueFunc( struct MinList *list, ptr2func func, void* userdata )
{
   struct FuncNode *node;

   if( ( node = AllocFuncNode( func, userdata ) ) != NULL )
   {
      AddTail( (struct List *)list, (struct Node *)node );
   }
   return node;
}

