#ifndef FUNCLISTS_H
#define FUNCLISTS_H

#include <exec/types.h>
#include <exec/lists.h>
#include <exec/nodes.h>
#include "AutoCleanUp.h"

/* already defined in AutoCleanUp.h  -- EDB */
/* as typedef void (*ptr2func)( void* ); */
/* Which is correct????                  */

/* typedef long (*ptr2func)( void* ); */

struct FuncNode
{
   struct MinNode  fn_Node;
   ptr2func        func;
   void           *UserData;
};


struct FuncNode*
AllocFuncNode( ptr2func func, void* userdata );

void
FreeFuncNode( struct FuncNode* );


struct FuncNode*
PushFunc ( struct MinList *list, ptr2func func, void* userdata );

struct FuncNode*
QueueFunc ( struct MinList *list, ptr2func func, void* userdata );


#endif
